#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_JuKunEggCFG.h"
std::auto_ptr<Fish_JuKunEggCFG> Fish_JuKunEggCFG::msSingleton(nullptr);

int Fish_JuKunEggCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JuKunEggCFGData* Fish_JuKunEggCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_JuKunEggCFGData>& Fish_JuKunEggCFG::GetMapData()
{
	return mMapData;
}

void Fish_JuKunEggCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_JuKunEggCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JuKunEggCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mMinimumScore = element->IntAttribute("MinimumScore");
		data.mMaximumScore = element->IntAttribute("MaximumScore");
		data.mRandomMinimum = element->IntAttribute("RandomMinimum");
		data.mRandomMaximum = element->IntAttribute("RandomMaximum");
		data.mweight = element->IntAttribute("weight");
		data.mResource = element->Attribute("Resource");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_JuKunEggCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunEggCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_JuKunEggCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_JuKunEggCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_JuKunEggCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "MinimumScore", data.mMinimumScore);
		LuaCfgHelper::readInt(L, "MaximumScore", data.mMaximumScore);
		LuaCfgHelper::readInt(L, "RandomMinimum", data.mRandomMinimum);
		LuaCfgHelper::readInt(L, "RandomMaximum", data.mRandomMaximum);
		LuaCfgHelper::readInt(L, "weight", data.mweight);
		LuaCfgHelper::readString(L, "Resource", data.mResource);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_JuKunEggCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JuKunEggCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_JuKunEggCFG* Fish_JuKunEggCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JuKunEggCFG());
	}
	return msSingleton.get();
}

void Fish_JuKunEggCFG::Release()
{
	msSingleton.reset(nullptr);
}
